/* Generated by re2c 1.1.1 on Tue Oct  8 03:08:34 2019 */
#line 1 "../snl.re"
/*************************************************************************\
Copyright (c) 2010-2015 Helmholtz-Zentrum Berlin f. Materialien
                        und Energie GmbH, Germany (HZB)
This file is distributed subject to a Software License Agreement found
in the file LICENSE that is included with this distribution.
\*************************************************************************/
/*************************************************************************\
                    Lexer specification/implementation
\*************************************************************************/
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#include "snl.h"
#include "main.h"
#include "parser.h"

#define	TOK_EOI		0

typedef unsigned char uchar;

#define	BSIZE	8192

#define	YYCTYPE			uchar
#define	YYCURSOR		cursor
#define	YYLIMIT			s->lim
#define	YYMARKER		s->ptr
#define	YYFILL(dummy)		cursor = fill(s, cursor);
#define	YYDEBUG(state, current) report("state = %d, current = %c\n", state, current);

#define	RET(i,r) {\
	s->cur = cursor;\
	t->str = r;\
	return TOK_ ## i;\
}

#define OPERATOR		RET
#define LITERAL(t,e,n) 		RET(t,n)
#define KEYWORD 		RET
#define TYPEWORD		RET
#define IDENTIFIER(t,e,n)	RET(t,n)
#define DELIMITER		RET

#define DONE			RET(EOI,"")

typedef struct Scanner {
	uchar	*bot;	/* pointer to bottom (start) of buffer */
	uchar	*tok;	/* pointer to start of current token */
	uchar	*end;	/* pointer to (temporary) end of current token */
	uchar	*ptr;	/* marker for backtracking (always > tok) */
	uchar	*cur;	/* saved scan position between calls to scan() */
	uchar	*lim;	/* pointer to one position after last read char */
	uchar	*top;	/* pointer to (one after) top of allocated buffer */
	uchar	*eof;	/* pointer to (one after) last char in file (or 0) */
	const char *file;	/* source file name */
	int	line;	/* line number */
	FILE	*in;
} Scanner;

static void scan_report(Scanner *s, const char *format, ...)
__attribute__((format(printf,2,3)));

static void scan_report(Scanner *s, const char *format, ...)
{
	va_list args;

	report_loc(s->file, s->line);
	va_start(args, format);
	fprintf(stderr, "lexical error: ");
	vfprintf(stderr, format, args);
	va_end(args);
}

/*
From the re2c docs:

   The generated code "calls" YYFILL(n) when the buffer needs (re)filling: at
   least n additional characters should be provided. YYFILL(n) should adjust
   YYCURSOR, YYLIMIT, YYMARKER and YYCTXMARKER as needed. Note that for typical
   programming languages n will be the length of the longest keyword plus one.

We also add a '\n' byte at the end of the file as sentinel.
*/
static uchar *fill(Scanner *s, uchar *cursor) {
	/* does not touch s->cur, instead works with argument cursor */
	if (!s->eof) {
		uint read_cnt;			/* number of bytes read */
		int garbage = s->tok - s->bot;	/* number of garbage bytes */
		int valid = s->lim - s->tok;	/* number of still valid bytes to copy */
		uchar *token = s->tok;		/* start of valid bytes */
		int space = (s->top - s->lim) + garbage;
						/* remaining space after garbage collection */
		int need_alloc = space < BSIZE;	/* do we need to allocate a new buffer? */

		assert(valid >= 0);

		/* anything below s->tok is garbage, collect it */
		if (garbage) {
#ifdef DEBUG
			report("fill: garbage=%u, need_alloc=%d\n", garbage, need_alloc);
#endif
			if (!need_alloc) {
				/* shift valid buffer content down to bottom of buffer */
				memmove(s->bot, token, (size_t)valid);
			}
			/* adjust pointers */
			s->tok = s->bot;	/* same as s->tok -= garbage */
			s->ptr -= garbage;
			cursor -= garbage;
			s->lim -= garbage;
			s->end -= garbage;
			/* invariant: s->bot, s->top, s->eof, s->lim - s->tok */
		}
		/* increase the buffer size if necessary, ensuring that we have
		   at least BSIZE bytes of free space to fill (after s->lim) */
		if (need_alloc) {
			uchar *buf;

			assert(s->lim - s->bot >= 0);
			buf = (uchar*) malloc(((size_t)(s->lim - s->bot) + BSIZE)*sizeof(uchar));
#ifdef DEBUG
			report("fill: need_alloc, bot: before=%p after=%p\n", s->bot, buf);
#endif
			memcpy(buf, token, (size_t)valid);
			s->tok = buf;
			s->end = &buf[s->end - s->bot];
			s->ptr = &buf[s->ptr - s->bot];
			cursor = &buf[cursor - s->bot];
			s->lim = &buf[s->lim - s->bot];
			s->top = s->lim + BSIZE;
			free(s->bot);
			s->bot = buf;
		}
		/* fill the buffer, starting at s->lim, by reading a chunk of
		   BSIZE bytes (or less if eof is encountered) */
		if ((read_cnt = fread(s->lim, sizeof(uchar), BSIZE, s->in)) != BSIZE) {
			if (ferror(s->in)) {
				perror("error reading input");
				exit(EXIT_FAILURE);
			}
			if (feof(s->in)) {
				s->eof = &s->lim[read_cnt];
				/* insert sentinel and increase s->eof */
				*(s->eof)++ = '\n';
			}
		}
		s->lim += read_cnt;	/* adjust limit */
	}
	return cursor;
}

/* alias strdup_from_to: duplicate string from start to (exclusive) stop */
static char *strdupft(uchar *start, uchar *stop) {
	char *result;
	size_t n;
	assert (stop - start >= 0);
	n = (size_t)(stop - start);
	result = malloc(n+1);
	memcpy(result, start, n);
	result[n] = 0;
	return result;
}

/*
 * Note: Linemarkers differ between compilers. The MS C preprocessor outputs
 * "#line <linenum> <filename>" directives, while gcc leaves off the "line".
 */

#line 184 "../snl.re"


static int scan(Scanner *s, Token *t) {
	uchar *cursor = s->cur;
	int in_c_code = 0;
	/*
	Note: Must use a temporary offset for (parts of) line_marker.
	Normally we use s->tok to remember start positions. But line_markers
	can appear nested inside c_code block tokens, so using s->tok for
	line_markers would destroy them.
	*/
	int line_marker_part = 0;

	s->end = 0;

snl:
	if (in_c_code)
		goto c_code;
	t->line = s->line;
	t->file = s->file;
	s->tok = cursor;


#line 198 "lexer.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  51,   0,  50,  50,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 51,  48,  48,  48,  48,  48,  48,  32, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		188, 188, 188, 188, 188, 188, 188, 188, 
		188, 188,  48,  48,  48,  48,  48,  48, 
		 48, 184, 184, 184, 184, 184, 184,  56, 
		 56,  56,  56,  56, 120,  56,  56,  56, 
		 56,  56,  56,  56,  56, 120,  56,  56, 
		 56,  56,  56,  48,  32,  48,  48,  56, 
		 48, 184, 184, 184, 184, 184, 184,  56, 
		 56,  56,  56,  56, 120,  56,  56,  56, 
		 56,  56,  56,  56,  56, 120,  56,  56, 
		 56,  56,  56,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
		 48,  48,  48,  48,  48,  48,  48,  48, 
	};
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 1) {
		goto yy4;
	}
	switch (yych) {
	case '\t':
	case '\n':	goto yy7;
	case '\v':
	case '\f':	goto yy9;
	case ' ':
	case '!':	goto yy11;
	case '"':	goto yy13;
	case '#':	goto yy15;
	case '%':	goto yy16;
	case '&':	goto yy18;
	case '\'':	goto yy20;
	case '(':	goto yy21;
	case ')':	goto yy23;
	case '*':	goto yy25;
	case '+':	goto yy27;
	case ',':	goto yy29;
	case '-':	goto yy31;
	case '.':	goto yy33;
	case '/':	goto yy35;
	case '0':	goto yy37;
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy39;
	case ':':	goto yy41;
	case ';':	goto yy43;
	case '<':	goto yy45;
	case '=':	goto yy47;
	case '>':	goto yy49;
	case '?':	goto yy51;
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'g':
	case 'h':
	case 'j':
	case 'k':
	case 'n':
	case 'q':
	case 'x':
	case 'y':
	case 'z':	goto yy53;
	case '[':	goto yy56;
	case ']':	goto yy58;
	case '^':	goto yy60;
	case 'a':	goto yy62;
	case 'b':	goto yy63;
	case 'c':	goto yy64;
	case 'd':	goto yy65;
	case 'e':	goto yy66;
	case 'f':	goto yy67;
	case 'i':	goto yy68;
	case 'l':	goto yy69;
	case 'm':	goto yy70;
	case 'o':	goto yy71;
	case 'p':	goto yy72;
	case 'r':	goto yy73;
	case 's':	goto yy74;
	case 't':	goto yy75;
	case 'u':	goto yy76;
	case 'v':	goto yy77;
	case 'w':	goto yy78;
	case '{':	goto yy79;
	case '|':	goto yy81;
	case '}':	goto yy83;
	case '~':	goto yy85;
	default:	goto yy2;
	}
yy2:
	++YYCURSOR;
yy3:
#line 338 "../snl.re"
	{ scan_report(s, "invalid character\n"); DONE; }
#line 344 "lexer.c"
yy4:
	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 6) YYFILL(6);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 1) {
		goto yy4;
	}
	if (yych <= '\n') goto yy6;
	if (yych <= '\f') goto yy9;
	if (yych == '#') goto yy87;
yy6:
#line 337 "../snl.re"
	{ goto snl; }
#line 359 "lexer.c"
yy7:
	++YYCURSOR;
#line 207 "../snl.re"
	{
				if(cursor == s->eof) DONE;
				s->line++;
				goto snl;
			}
#line 368 "lexer.c"
yy9:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 2) {
		goto yy9;
	}
	goto yy6;
yy11:
	yych = *++YYCURSOR;
	if (yych == '=') goto yy89;
#line 325 "../snl.re"
	{ OPERATOR(NOT,		"!"); }
#line 382 "lexer.c"
yy13:
	++YYCURSOR;
#line 216 "../snl.re"
	{
				s->tok = s->end = cursor;
				goto string_const;
			}
#line 390 "lexer.c"
yy15:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x1F) {
		if (yych == '\t') goto yy91;
		goto yy3;
	} else {
		if (yych <= ' ') goto yy91;
		if (yych == 'l') goto yy94;
		goto yy3;
	}
yy16:
	yych = *++YYCURSOR;
	if (yych <= '<') {
		if (yych == '%') goto yy95;
	} else {
		if (yych <= '=') goto yy98;
		if (yych == '{') goto yy100;
	}
#line 331 "../snl.re"
	{ OPERATOR(MOD,		"%"); }
#line 412 "lexer.c"
yy18:
	yych = *++YYCURSOR;
	if (yych == '&') goto yy102;
	if (yych == '=') goto yy104;
#line 324 "../snl.re"
	{ OPERATOR(AMPERSAND,	"&"); }
#line 419 "lexer.c"
yy20:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '\n') goto yy3;
	goto yy107;
yy21:
	++YYCURSOR;
#line 319 "../snl.re"
	{ DELIMITER(LPAREN,	"("); }
#line 429 "lexer.c"
yy23:
	++YYCURSOR;
#line 320 "../snl.re"
	{ DELIMITER(RPAREN,	")"); }
#line 434 "lexer.c"
yy25:
	yych = *++YYCURSOR;
	if (yych == '=') goto yy110;
#line 329 "../snl.re"
	{ OPERATOR(ASTERISK,	"*"); }
#line 440 "lexer.c"
yy27:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy112;
	if (yych == '=') goto yy114;
#line 328 "../snl.re"
	{ OPERATOR(ADD,		"+"); }
#line 447 "lexer.c"
yy29:
	++YYCURSOR;
#line 316 "../snl.re"
	{ DELIMITER(COMMA,	","); }
#line 452 "lexer.c"
yy31:
	yych = *++YYCURSOR;
	if (yych <= '<') {
		if (yych == '-') goto yy116;
	} else {
		if (yych <= '=') goto yy118;
		if (yych <= '>') goto yy120;
	}
#line 327 "../snl.re"
	{ OPERATOR(SUB,		"-"); }
#line 463 "lexer.c"
yy33:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy34;
	if (yych <= '9') goto yy122;
yy34:
#line 323 "../snl.re"
	{ OPERATOR(PERIOD,	"."); }
#line 471 "lexer.c"
yy35:
	yych = *++YYCURSOR;
	if (yych <= '.') {
		if (yych == '*') goto yy125;
	} else {
		if (yych <= '/') goto yy127;
		if (yych == '=') goto yy130;
	}
#line 330 "../snl.re"
	{ OPERATOR(SLASH,	"/"); }
#line 482 "lexer.c"
yy37:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == 'X') goto yy135;
	if (yych == 'x') goto yy135;
	goto yy40;
yy38:
#line 287 "../snl.re"
	{ LITERAL(INTCON, integer_literal, strdupft(s->tok, cursor)); }
#line 492 "lexer.c"
yy39:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy40:
	if (yybm[0+yych] & 4) {
		goto yy39;
	}
	if (yych <= 'T') {
		if (yych <= 'D') {
			if (yych == '.') goto yy122;
			goto yy38;
		} else {
			if (yych <= 'E') goto yy132;
			if (yych == 'L') goto yy133;
			goto yy38;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'U') goto yy133;
			if (yych == 'e') goto yy132;
			goto yy38;
		} else {
			if (yych <= 'l') goto yy133;
			if (yych == 'u') goto yy133;
			goto yy38;
		}
	}
yy41:
	++YYCURSOR;
#line 317 "../snl.re"
	{ OPERATOR(COLON,	":"); }
#line 526 "lexer.c"
yy43:
	++YYCURSOR;
#line 313 "../snl.re"
	{ DELIMITER(SEMICOLON,	";"); }
#line 531 "lexer.c"
yy45:
	yych = *++YYCURSOR;
	if (yych <= ';') goto yy46;
	if (yych <= '<') goto yy136;
	if (yych <= '=') goto yy138;
yy46:
#line 332 "../snl.re"
	{ OPERATOR(LT,		"<"); }
#line 540 "lexer.c"
yy47:
	yych = *++YYCURSOR;
	if (yych == '=') goto yy140;
#line 318 "../snl.re"
	{ OPERATOR(EQUAL,	"="); }
#line 546 "lexer.c"
yy49:
	yych = *++YYCURSOR;
	if (yych <= '<') goto yy50;
	if (yych <= '=') goto yy142;
	if (yych <= '>') goto yy144;
yy50:
#line 333 "../snl.re"
	{ OPERATOR(GT,		">"); }
#line 555 "lexer.c"
yy51:
	++YYCURSOR;
#line 336 "../snl.re"
	{ OPERATOR(QUESTION,	"?"); }
#line 560 "lexer.c"
yy53:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy54:
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 285 "../snl.re"
	{ IDENTIFIER(NAME, identifier, strdupft(s->tok, cursor)); }
#line 571 "lexer.c"
yy56:
	++YYCURSOR;
#line 321 "../snl.re"
	{ DELIMITER(LBRACKET,	"["); }
#line 576 "lexer.c"
yy58:
	++YYCURSOR;
#line 322 "../snl.re"
	{ DELIMITER(RBRACKET,	"]"); }
#line 581 "lexer.c"
yy60:
	yych = *++YYCURSOR;
	if (yych == '=') goto yy146;
#line 334 "../snl.re"
	{ OPERATOR(CARET,	"^"); }
#line 587 "lexer.c"
yy62:
	yych = *++YYCURSOR;
	if (yych == 's') goto yy148;
	goto yy54;
yy63:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy149;
	goto yy54;
yy64:
	yych = *++YYCURSOR;
	if (yych == 'h') goto yy150;
	if (yych == 'o') goto yy151;
	goto yy54;
yy65:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy152;
	goto yy54;
yy66:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'l':	goto yy153;
	case 'n':	goto yy154;
	case 'v':	goto yy155;
	case 'x':	goto yy156;
	default:	goto yy54;
	}
yy67:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy157;
	if (yych == 'o') goto yy158;
	goto yy54;
yy68:
	yych = *++YYCURSOR;
	if (yych == 'f') goto yy159;
	if (yych == 'n') goto yy161;
	goto yy54;
yy69:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy162;
	goto yy54;
yy70:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy163;
	goto yy54;
yy71:
	yych = *++YYCURSOR;
	if (yych == 'p') goto yy164;
	goto yy54;
yy72:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy165;
	goto yy54;
yy73:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy166;
	goto yy54;
yy74:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'e':	goto yy167;
	case 'h':	goto yy168;
	case 'i':	goto yy169;
	case 's':	goto yy170;
	case 't':	goto yy172;
	case 'y':	goto yy173;
	default:	goto yy54;
	}
yy75:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy174;
	if (yych == 'y') goto yy176;
	goto yy54;
yy76:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy177;
	if (yych == 'n') goto yy178;
	goto yy54;
yy77:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy179;
	goto yy54;
yy78:
	yych = *++YYCURSOR;
	if (yych == 'h') goto yy180;
	goto yy54;
yy79:
	++YYCURSOR;
#line 314 "../snl.re"
	{ DELIMITER(LBRACE,	"{"); }
#line 677 "lexer.c"
yy81:
	yych = *++YYCURSOR;
	if (yych == '=') goto yy181;
	if (yych == '|') goto yy183;
#line 335 "../snl.re"
	{ OPERATOR(VBAR,	"|"); }
#line 684 "lexer.c"
yy83:
	++YYCURSOR;
#line 315 "../snl.re"
	{ DELIMITER(RBRACE,	"}"); }
#line 689 "lexer.c"
yy85:
	++YYCURSOR;
#line 326 "../snl.re"
	{ OPERATOR(TILDE,	"~"); }
#line 694 "lexer.c"
yy87:
	yych = *++YYCURSOR;
	if (yych <= 0x1F) {
		if (yych == '\t') goto yy91;
	} else {
		if (yych <= ' ') goto yy91;
		if (yych == 'l') goto yy94;
	}
yy88:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 2) {
		if (yyaccept <= 1) {
			if (yyaccept == 0) {
				goto yy6;
			} else {
				goto yy3;
			}
		} else {
			goto yy38;
		}
	} else {
		if (yyaccept == 3) {
			goto yy93;
		} else {
			goto yy124;
		}
	}
yy89:
	++YYCURSOR;
#line 312 "../snl.re"
	{ OPERATOR(NE,		"!="); }
#line 726 "lexer.c"
yy91:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	if (yych <= 0x1F) {
		if (yych == '\t') goto yy91;
	} else {
		if (yych <= ' ') goto yy91;
		if (yych == 'l') goto yy94;
	}
yy93:
#line 212 "../snl.re"
	{
				line_marker_part = cursor - s->tok;
				goto line_marker;
			}
#line 744 "lexer.c"
yy94:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy185;
	goto yy88;
yy95:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == '\t') goto yy95;
	if (yych == ' ') goto yy95;
#line 230 "../snl.re"
	{
				s->tok = s->end = cursor;
				goto c_code_line;
			}
#line 760 "lexer.c"
yy98:
	++YYCURSOR;
#line 298 "../snl.re"
	{ OPERATOR(MODEQ,	"%="); }
#line 765 "lexer.c"
yy100:
	++YYCURSOR;
#line 222 "../snl.re"
	{
				s->tok = cursor;
				in_c_code = 1;
#ifdef DEBUG
				report("in_c_code: cursor=%p, tok=%p\n", cursor, s->tok);
#endif
				goto c_code;
			}
#line 777 "lexer.c"
yy102:
	++YYCURSOR;
#line 307 "../snl.re"
	{ OPERATOR(ANDAND,	"&&"); }
#line 782 "lexer.c"
yy104:
	++YYCURSOR;
#line 299 "../snl.re"
	{ OPERATOR(ANDEQ,	"&="); }
#line 787 "lexer.c"
yy106:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy107:
	if (yybm[0+yych] & 16) {
		goto yy106;
	}
	if (yych <= '\n') goto yy88;
	if (yych >= '(') goto yy109;
	++YYCURSOR;
	goto yy38;
yy109:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'b') {
		if (yych <= '7') {
			if (yych <= '&') {
				if (yych == '"') goto yy106;
				goto yy88;
			} else {
				if (yych <= '\'') goto yy106;
				if (yych <= '/') goto yy88;
				goto yy106;
			}
		} else {
			if (yych <= '[') {
				if (yych == '?') goto yy106;
				goto yy88;
			} else {
				if (yych <= '\\') goto yy106;
				if (yych <= '`') goto yy88;
				goto yy106;
			}
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'm') {
				if (yych == 'f') goto yy106;
				goto yy88;
			} else {
				if (yych <= 'n') goto yy106;
				if (yych <= 'q') goto yy88;
				goto yy106;
			}
		} else {
			if (yych <= 'u') {
				if (yych == 't') goto yy106;
				goto yy88;
			} else {
				if (yych <= 'v') goto yy106;
				if (yych == 'x') goto yy186;
				goto yy88;
			}
		}
	}
yy110:
	++YYCURSOR;
#line 296 "../snl.re"
	{ OPERATOR(MULEQ,	"*="); }
#line 849 "lexer.c"
yy112:
	++YYCURSOR;
#line 304 "../snl.re"
	{ OPERATOR(INCR,	"++"); }
#line 854 "lexer.c"
yy114:
	++YYCURSOR;
#line 294 "../snl.re"
	{ OPERATOR(ADDEQ,	"+="); }
#line 859 "lexer.c"
yy116:
	++YYCURSOR;
#line 305 "../snl.re"
	{ OPERATOR(DECR,	"--"); }
#line 864 "lexer.c"
yy118:
	++YYCURSOR;
#line 295 "../snl.re"
	{ OPERATOR(SUBEQ,	"-="); }
#line 869 "lexer.c"
yy120:
	++YYCURSOR;
#line 306 "../snl.re"
	{ OPERATOR(POINTER,	"->"); }
#line 874 "lexer.c"
yy122:
	yyaccept = 4;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'K') {
		if (yych <= 'D') {
			if (yych <= '/') goto yy124;
			if (yych <= '9') goto yy122;
		} else {
			if (yych <= 'E') goto yy132;
			if (yych <= 'F') goto yy187;
		}
	} else {
		if (yych <= 'e') {
			if (yych <= 'L') goto yy187;
			if (yych >= 'e') goto yy132;
		} else {
			if (yych <= 'f') goto yy187;
			if (yych == 'l') goto yy187;
		}
	}
yy124:
#line 290 "../snl.re"
	{ LITERAL(FPCON, floating_point_literal, strdupft(s->tok, cursor)); }
#line 900 "lexer.c"
yy125:
	++YYCURSOR;
#line 220 "../snl.re"
	{ goto comment; }
#line 905 "lexer.c"
yy127:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 32) {
		goto yy127;
	}
#line 221 "../snl.re"
	{ goto snl; }
#line 915 "lexer.c"
yy130:
	++YYCURSOR;
#line 297 "../snl.re"
	{ OPERATOR(DIVEQ,	"/="); }
#line 920 "lexer.c"
yy132:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy188;
		goto yy88;
	} else {
		if (yych <= '-') goto yy188;
		if (yych <= '/') goto yy88;
		if (yych <= '9') goto yy189;
		goto yy88;
	}
yy133:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 64) {
		goto yy133;
	}
	goto yy38;
yy135:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy191;
	}
	goto yy88;
yy136:
	yych = *++YYCURSOR;
	if (yych == '=') goto yy193;
#line 303 "../snl.re"
	{ OPERATOR(LSHIFT,	"<<"); }
#line 951 "lexer.c"
yy138:
	++YYCURSOR;
#line 309 "../snl.re"
	{ OPERATOR(LE,		"<="); }
#line 956 "lexer.c"
yy140:
	++YYCURSOR;
#line 311 "../snl.re"
	{ OPERATOR(EQ,		"=="); }
#line 961 "lexer.c"
yy142:
	++YYCURSOR;
#line 310 "../snl.re"
	{ OPERATOR(GE,		">="); }
#line 966 "lexer.c"
yy144:
	yych = *++YYCURSOR;
	if (yych == '=') goto yy195;
#line 302 "../snl.re"
	{ OPERATOR(RSHIFT,	">>"); }
#line 972 "lexer.c"
yy146:
	++YYCURSOR;
#line 300 "../snl.re"
	{ OPERATOR(XOREQ,	"^="); }
#line 977 "lexer.c"
yy148:
	yych = *++YYCURSOR;
	if (yych == 's') goto yy197;
	goto yy54;
yy149:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy198;
	goto yy54;
yy150:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy199;
	goto yy54;
yy151:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy200;
	goto yy54;
yy152:
	yych = *++YYCURSOR;
	if (yych == 'u') goto yy201;
	goto yy54;
yy153:
	yych = *++YYCURSOR;
	if (yych == 's') goto yy202;
	goto yy54;
yy154:
	yych = *++YYCURSOR;
	if (yych <= 's') goto yy54;
	if (yych <= 't') goto yy203;
	if (yych <= 'u') goto yy204;
	goto yy54;
yy155:
	yych = *++YYCURSOR;
	if (yych == 'f') goto yy205;
	goto yy54;
yy156:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy206;
	goto yy54;
yy157:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy207;
	goto yy54;
yy158:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy208;
	goto yy54;
yy159:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 248 "../snl.re"
	{ KEYWORD(IF,		"if"); }
#line 1031 "lexer.c"
yy161:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy210;
	goto yy54;
yy162:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy212;
	goto yy54;
yy163:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy213;
	goto yy54;
yy164:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy214;
	goto yy54;
yy165:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy215;
	goto yy54;
yy166:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy216;
	goto yy54;
yy167:
	yych = *++YYCURSOR;
	if (yych == 'q') goto yy217;
	goto yy54;
yy168:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy218;
	goto yy54;
yy169:
	yych = *++YYCURSOR;
	if (yych == 'z') goto yy219;
	goto yy54;
yy170:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 257 "../snl.re"
	{ KEYWORD(SS,		"ss"); }
#line 1075 "lexer.c"
yy172:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy220;
	if (yych == 'r') goto yy221;
	goto yy54;
yy173:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy222;
	goto yy54;
yy174:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 264 "../snl.re"
	{ KEYWORD(TO,		"to"); }
#line 1092 "lexer.c"
yy176:
	yych = *++YYCURSOR;
	if (yych == 'p') goto yy223;
	goto yy54;
yy177:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy224;
	goto yy54;
yy178:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy225;
	if (yych == 's') goto yy226;
	goto yy54;
yy179:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy227;
	goto yy54;
yy180:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy228;
	if (yych == 'i') goto yy229;
	goto yy54;
yy181:
	++YYCURSOR;
#line 301 "../snl.re"
	{ OPERATOR(OREQ,	"|="); }
#line 1119 "lexer.c"
yy183:
	++YYCURSOR;
#line 308 "../snl.re"
	{ OPERATOR(OROR,	"||"); }
#line 1124 "lexer.c"
yy185:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy230;
	goto yy88;
yy186:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy88;
		if (yych <= '9') goto yy106;
		goto yy88;
	} else {
		if (yych <= 'F') goto yy106;
		if (yych <= '`') goto yy88;
		if (yych <= 'f') goto yy106;
		goto yy88;
	}
yy187:
	++YYCURSOR;
	goto yy124;
yy188:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy88;
	if (yych >= ':') goto yy88;
yy189:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'K') {
		if (yych <= '9') {
			if (yych <= '/') goto yy124;
			goto yy189;
		} else {
			if (yych == 'F') goto yy187;
			goto yy124;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= 'L') goto yy187;
			if (yych <= 'e') goto yy124;
			goto yy187;
		} else {
			if (yych == 'l') goto yy187;
			goto yy124;
		}
	}
yy191:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy191;
	}
	if (yych <= 'U') {
		if (yych == 'L') goto yy133;
		if (yych <= 'T') goto yy38;
		goto yy133;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy38;
			goto yy133;
		} else {
			if (yych == 'u') goto yy133;
			goto yy38;
		}
	}
yy193:
	++YYCURSOR;
#line 293 "../snl.re"
	{ OPERATOR(LSHEQ,	"<<="); }
#line 1196 "lexer.c"
yy195:
	++YYCURSOR;
#line 292 "../snl.re"
	{ OPERATOR(RSHEQ,	">>="); }
#line 1201 "lexer.c"
yy197:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy231;
	goto yy54;
yy198:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy232;
	goto yy54;
yy199:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy233;
	goto yy54;
yy200:
	yych = *++YYCURSOR;
	if (yych <= 'r') goto yy54;
	if (yych <= 's') goto yy235;
	if (yych <= 't') goto yy236;
	goto yy54;
yy201:
	yych = *++YYCURSOR;
	if (yych == 'b') goto yy237;
	goto yy54;
yy202:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy238;
	goto yy54;
yy203:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy240;
	goto yy54;
yy204:
	yych = *++YYCURSOR;
	if (yych == 'm') goto yy241;
	goto yy54;
yy205:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy243;
	goto yy54;
yy206:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy244;
	goto yy54;
yy207:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy246;
	goto yy54;
yy208:
	yych = *++YYCURSOR;
	if (yych <= '^') {
		if (yych <= '9') {
			if (yych >= '0') goto yy53;
		} else {
			if (yych <= '@') goto yy209;
			if (yych <= 'Z') goto yy53;
		}
	} else {
		if (yych <= 'd') {
			if (yych != '`') goto yy53;
		} else {
			if (yych <= 'e') goto yy247;
			if (yych <= 'z') goto yy53;
		}
	}
yy209:
#line 246 "../snl.re"
	{ KEYWORD(FOR,		"for"); }
#line 1268 "lexer.c"
yy210:
	yych = *++YYCURSOR;
	if (yych <= '8') {
		if (yych <= '1') {
			if (yych <= '/') goto yy211;
			if (yych <= '0') goto yy53;
			goto yy248;
		} else {
			if (yych == '3') goto yy249;
			if (yych <= '7') goto yy53;
			goto yy250;
		}
	} else {
		if (yych <= '^') {
			if (yych <= '9') goto yy53;
			if (yych <= '@') goto yy211;
			if (yych <= 'Z') goto yy53;
		} else {
			if (yych == '`') goto yy211;
			if (yych <= 'z') goto yy53;
		}
	}
yy211:
#line 249 "../snl.re"
	{ TYPEWORD(INT,		"int"); }
#line 1294 "lexer.c"
yy212:
	yych = *++YYCURSOR;
	if (yych == 'g') goto yy251;
	goto yy54;
yy213:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy253;
	goto yy54;
yy214:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy254;
	goto yy54;
yy215:
	yych = *++YYCURSOR;
	if (yych == 'g') goto yy255;
	goto yy54;
yy216:
	yych = *++YYCURSOR;
	if (yych == 'u') goto yy256;
	goto yy54;
yy217:
	yych = *++YYCURSOR;
	if (yych == 'g') goto yy257;
	goto yy54;
yy218:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy258;
	goto yy54;
yy219:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy259;
	goto yy54;
yy220:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy260;
	goto yy54;
yy221:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy261;
	if (yych == 'u') goto yy262;
	goto yy54;
yy222:
	yych = *++YYCURSOR;
	if (yych == 'c') goto yy263;
	goto yy54;
yy223:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy265;
	goto yy54;
yy224:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy266;
	goto yy54;
yy225:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy267;
	goto yy54;
yy226:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy268;
	goto yy54;
yy227:
	yych = *++YYCURSOR;
	if (yych == 'd') goto yy269;
	goto yy54;
yy228:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy271;
	goto yy54;
yy229:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy273;
	goto yy54;
yy230:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy274;
	goto yy88;
yy231:
	yych = *++YYCURSOR;
	if (yych == 'g') goto yy275;
	goto yy54;
yy232:
	yych = *++YYCURSOR;
	if (yych == 'k') goto yy276;
	goto yy54;
yy233:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 236 "../snl.re"
	{ TYPEWORD(CHAR,	"char"); }
#line 1387 "lexer.c"
yy235:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy278;
	goto yy54;
yy236:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy280;
	goto yy54;
yy237:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy281;
	goto yy54;
yy238:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 240 "../snl.re"
	{ KEYWORD(ELSE,		"else"); }
#line 1407 "lexer.c"
yy240:
	yych = *++YYCURSOR;
	if (yych == 'y') goto yy282;
	goto yy54;
yy241:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 242 "../snl.re"
	{ TYPEWORD(ENUM,	"enum"); }
#line 1419 "lexer.c"
yy243:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy284;
	goto yy54;
yy244:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 244 "../snl.re"
	{ KEYWORD(EXIT,		"exit"); }
#line 1431 "lexer.c"
yy246:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy285;
	goto yy54;
yy247:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy287;
	goto yy54;
yy248:
	yych = *++YYCURSOR;
	if (yych == '6') goto yy288;
	goto yy54;
yy249:
	yych = *++YYCURSOR;
	if (yych == '2') goto yy289;
	goto yy54;
yy250:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy290;
	goto yy54;
yy251:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 250 "../snl.re"
	{ TYPEWORD(LONG,	"long"); }
#line 1459 "lexer.c"
yy253:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy291;
	goto yy54;
yy254:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy292;
	goto yy54;
yy255:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy293;
	goto yy54;
yy256:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy294;
	goto yy54;
yy257:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy295;
	goto yy54;
yy258:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy298;
	goto yy54;
yy259:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy300;
	goto yy54;
yy260:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy301;
	goto yy54;
yy261:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy303;
	goto yy54;
yy262:
	yych = *++YYCURSOR;
	if (yych == 'c') goto yy304;
	goto yy54;
yy263:
	yych = *++YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '@') {
			if (yych <= '/') goto yy264;
			if (yych <= '9') goto yy53;
		} else {
			if (yych == 'Q') goto yy305;
			goto yy53;
		}
	} else {
		if (yych <= '`') {
			if (yych == '_') goto yy53;
		} else {
			if (yych == 'q') goto yy307;
			if (yych <= 'z') goto yy53;
		}
	}
yy264:
#line 263 "../snl.re"
	{ KEYWORD(SYNC,		"sync"); }
#line 1521 "lexer.c"
yy265:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy309;
	goto yy54;
yy266:
	yych = *++YYCURSOR;
	if (yych <= '2') {
		if (yych == '1') goto yy310;
		goto yy54;
	} else {
		if (yych <= '3') goto yy311;
		if (yych == '8') goto yy312;
		goto yy54;
	}
yy267:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy313;
	goto yy54;
yy268:
	yych = *++YYCURSOR;
	if (yych == 'g') goto yy315;
	goto yy54;
yy269:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 268 "../snl.re"
	{ TYPEWORD(VOID,	"void"); }
#line 1551 "lexer.c"
yy271:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 269 "../snl.re"
	{ KEYWORD(WHEN,		"when"); }
#line 1559 "lexer.c"
yy273:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy316;
	goto yy54;
yy274:
	yych = *++YYCURSOR;
	if (yych == '\t') goto yy318;
	if (yych == ' ') goto yy318;
	goto yy88;
yy275:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy320;
	goto yy54;
yy276:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 235 "../snl.re"
	{ KEYWORD(BREAK,	"break"); }
#line 1580 "lexer.c"
yy278:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 237 "../snl.re"
	{ TYPEWORD(CONST,	"const"); }
#line 1588 "lexer.c"
yy280:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy322;
	goto yy54;
yy281:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy323;
	goto yy54;
yy282:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 241 "../snl.re"
	{ KEYWORD(ENTRY,	"entry"); }
#line 1604 "lexer.c"
yy284:
	yych = *++YYCURSOR;
	if (yych == 'g') goto yy325;
	goto yy54;
yy285:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 245 "../snl.re"
	{ TYPEWORD(FLOAT,	"float"); }
#line 1616 "lexer.c"
yy287:
	yych = *++YYCURSOR;
	if (yych == 'g') goto yy327;
	goto yy54;
yy288:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy328;
	goto yy54;
yy289:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy329;
	goto yy54;
yy290:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy330;
	goto yy54;
yy291:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy332;
	goto yy54;
yy292:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy333;
	goto yy54;
yy293:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy335;
	goto yy54;
yy294:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy336;
	goto yy54;
yy295:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy297;
		if (yych <= '9') goto yy295;
		if (yych >= 'A') goto yy295;
	} else {
		if (yych <= '_') {
			if (yych >= '_') goto yy295;
		} else {
			if (yych <= '`') goto yy297;
			if (yych <= 'z') goto yy295;
		}
	}
yy297:
#line 279 "../snl.re"
	{
		*cursor = 0;
		scan_report(s, "identifier '%s'starts with reserved prefix\n", s->tok);
		DONE;
	}
#line 1672 "lexer.c"
yy298:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 255 "../snl.re"
	{ TYPEWORD(SHORT,	"short"); }
#line 1680 "lexer.c"
yy300:
	yych = *++YYCURSOR;
	if (yych == 'f') goto yy338;
	goto yy54;
yy301:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 258 "../snl.re"
	{ KEYWORD(STATE,	"state"); }
#line 1692 "lexer.c"
yy303:
	yych = *++YYCURSOR;
	if (yych == 'g') goto yy340;
	goto yy54;
yy304:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy342;
	goto yy54;
yy305:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 261 "../snl.re"
	{ KEYWORD(SYNCQ,	"syncQ"); }
#line 1708 "lexer.c"
yy307:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 262 "../snl.re"
	{ KEYWORD(SYNCQ,	"syncq"); }
#line 1716 "lexer.c"
yy309:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy344;
	goto yy54;
yy310:
	yych = *++YYCURSOR;
	if (yych == '6') goto yy345;
	goto yy54;
yy311:
	yych = *++YYCURSOR;
	if (yych == '2') goto yy346;
	goto yy54;
yy312:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy347;
	goto yy54;
yy313:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 266 "../snl.re"
	{ TYPEWORD(UNION,	"union"); }
#line 1740 "lexer.c"
yy315:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy348;
	goto yy54;
yy316:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 270 "../snl.re"
	{ KEYWORD(WHILE,	"while"); }
#line 1752 "lexer.c"
yy318:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == '\t') goto yy318;
	if (yych == ' ') goto yy318;
	goto yy93;
yy320:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 234 "../snl.re"
	{ KEYWORD(ASSIGN,	"assign"); }
#line 1767 "lexer.c"
yy322:
	yych = *++YYCURSOR;
	if (yych == 'u') goto yy349;
	goto yy54;
yy323:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 239 "../snl.re"
	{ TYPEWORD(DOUBLE,	"double"); }
#line 1779 "lexer.c"
yy325:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 243 "../snl.re"
	{ TYPEWORD(EVFLAG,	"evflag"); }
#line 1787 "lexer.c"
yy327:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy350;
	goto yy54;
yy328:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy352;
	goto yy54;
yy329:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy354;
	goto yy54;
yy330:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 272 "../snl.re"
	{ TYPEWORD(INT8T,  	"int8_t"); }
#line 1807 "lexer.c"
yy332:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy356;
	goto yy54;
yy333:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 252 "../snl.re"
	{ KEYWORD(OPTION,	"option"); }
#line 1819 "lexer.c"
yy335:
	yych = *++YYCURSOR;
	if (yych == 'm') goto yy358;
	goto yy54;
yy336:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 254 "../snl.re"
	{ KEYWORD(RETURN,	"return"); }
#line 1831 "lexer.c"
yy338:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 256 "../snl.re"
	{ TYPEWORD(SIZEOF,	"sizeof"); }
#line 1839 "lexer.c"
yy340:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 259 "../snl.re"
	{ KEYWORD(STRING,	"string"); }
#line 1847 "lexer.c"
yy342:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 260 "../snl.re"
	{ TYPEWORD(STRUCT,	"struct"); }
#line 1855 "lexer.c"
yy344:
	yych = *++YYCURSOR;
	if (yych == 'm') goto yy360;
	goto yy54;
yy345:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy361;
	goto yy54;
yy346:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy362;
	goto yy54;
yy347:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy363;
	goto yy54;
yy348:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy365;
	goto yy54;
yy349:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy366;
	goto yy54;
yy350:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 247 "../snl.re"
	{ TYPEWORD(FOREIGN,	"foreign"); }
#line 1887 "lexer.c"
yy352:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 274 "../snl.re"
	{ TYPEWORD(INT16T, 	"int16_t"); }
#line 1895 "lexer.c"
yy354:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 276 "../snl.re"
	{ TYPEWORD(INT32T, 	"int32_t"); }
#line 1903 "lexer.c"
yy356:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 251 "../snl.re"
	{ KEYWORD(MONITOR,	"monitor"); }
#line 1911 "lexer.c"
yy358:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 253 "../snl.re"
	{ KEYWORD(PROGRAM,	"program"); }
#line 1919 "lexer.c"
yy360:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy368;
	goto yy54;
yy361:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy370;
	goto yy54;
yy362:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy372;
	goto yy54;
yy363:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 273 "../snl.re"
	{ TYPEWORD(UINT8T, 	"uint8_t"); }
#line 1939 "lexer.c"
yy365:
	yych = *++YYCURSOR;
	if (yych == 'd') goto yy374;
	goto yy54;
yy366:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 238 "../snl.re"
	{ KEYWORD(CONTINUE,	"continue"); }
#line 1951 "lexer.c"
yy368:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 265 "../snl.re"
	{ TYPEWORD(TYPENAME,	"typename"); }
#line 1959 "lexer.c"
yy370:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 275 "../snl.re"
	{ TYPEWORD(UINT16T,	"uint16_t"); }
#line 1967 "lexer.c"
yy372:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 277 "../snl.re"
	{ TYPEWORD(UINT32T,	"uint32_t"); }
#line 1975 "lexer.c"
yy374:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy53;
	}
#line 267 "../snl.re"
	{ TYPEWORD(UNSIGNED,	"unsigned"); }
#line 1983 "lexer.c"
}
#line 339 "../snl.re"


string_const:

#line 1990 "lexer.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128,   0, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128,   0, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128,   0, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
	};
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy378;
	}
	if (yych <= '\n') goto yy381;
	if (yych <= '"') goto yy383;
	goto yy385;
yy378:
	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy378;
	}
	if (yych >= '#') goto yy386;
yy380:
#line 344 "../snl.re"
	{ goto string_const; }
#line 2048 "lexer.c"
yy381:
	++YYCURSOR;
yy382:
#line 349 "../snl.re"
	{ scan_report(s, "invalid character in string constant\n"); DONE; }
#line 2054 "lexer.c"
yy383:
	++YYCURSOR;
#line 345 "../snl.re"
	{
				s->end = cursor - 1;
				goto string_cat;
			}
#line 2062 "lexer.c"
yy385:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'b') {
		if (yych <= '7') {
			if (yych <= '&') {
				if (yych == '"') goto yy378;
				goto yy382;
			} else {
				if (yych <= '\'') goto yy378;
				if (yych <= '/') goto yy382;
				goto yy378;
			}
		} else {
			if (yych <= '[') {
				if (yych == '?') goto yy378;
				goto yy382;
			} else {
				if (yych <= '\\') goto yy378;
				if (yych <= '`') goto yy382;
				goto yy378;
			}
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'm') {
				if (yych == 'f') goto yy378;
				goto yy382;
			} else {
				if (yych <= 'n') goto yy378;
				if (yych <= 'q') goto yy382;
				goto yy378;
			}
		} else {
			if (yych <= 'u') {
				if (yych == 't') goto yy378;
				goto yy382;
			} else {
				if (yych <= 'v') goto yy378;
				if (yych == 'x') goto yy388;
				goto yy382;
			}
		}
	}
yy386:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'b') {
		if (yych <= '7') {
			if (yych <= '&') {
				if (yych == '"') goto yy378;
			} else {
				if (yych <= '\'') goto yy378;
				if (yych >= '0') goto yy378;
			}
		} else {
			if (yych <= '[') {
				if (yych == '?') goto yy378;
			} else {
				if (yych <= '\\') goto yy378;
				if (yych >= 'a') goto yy378;
			}
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'm') {
				if (yych == 'f') goto yy378;
			} else {
				if (yych <= 'n') goto yy378;
				if (yych >= 'r') goto yy378;
			}
		} else {
			if (yych <= 'u') {
				if (yych == 't') goto yy378;
			} else {
				if (yych <= 'v') goto yy378;
				if (yych == 'x') goto yy388;
			}
		}
	}
yy387:
	YYCURSOR = YYMARKER;
	if (yyaccept == 0) {
		goto yy380;
	} else {
		goto yy382;
	}
yy388:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy387;
		if (yych <= '9') goto yy378;
		goto yy387;
	} else {
		if (yych <= 'F') goto yy378;
		if (yych <= '`') goto yy387;
		if (yych <= 'f') goto yy378;
		goto yy387;
	}
}
#line 350 "../snl.re"


string_cat:

#line 2171 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy393;
	}
	if (yych <= 0x08) goto yy391;
	if (yych <= '\n') goto yy396;
	if (yych == '"') goto yy398;
yy391:
	++YYCURSOR;
#line 370 "../snl.re"
	{
				cursor -= 1;
				LITERAL(STRCON, string_literal, strdupft(s->tok, s->end));
			}
#line 2223 "lexer.c"
yy393:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy393;
	}
#line 354 "../snl.re"
	{ goto string_cat; }
#line 2233 "lexer.c"
yy396:
	++YYCURSOR;
#line 355 "../snl.re"
	{
				if (cursor == s->eof) {
					cursor -= 1;
					LITERAL(STRCON, string_literal, strdupft(s->tok, s->end));
				}
				s->line++;
				goto string_cat;
			}
#line 2245 "lexer.c"
yy398:
	++YYCURSOR;
#line 363 "../snl.re"
	{
				int len = s->end - s->tok;
				assert(len >= 0);
				memmove(cursor - len, s->tok, (size_t)len);
				s->tok = cursor - len;
				goto string_const;
			}
#line 2256 "lexer.c"
}
#line 374 "../snl.re"


line_marker:

#line 2263 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		 64,  64,  64,  64,  64,  64,  64,  64, 
		 64,  64,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 64) {
		goto yy404;
	}
	++YYCURSOR;
#line 383 "../snl.re"
	{ goto line_marker_skip; }
#line 2308 "lexer.c"
yy404:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy407;
	}
	if (yych <= '/') goto yy406;
	if (yych <= '9') goto yy404;
yy406:
#line 378 "../snl.re"
	{
				s->line = atoi((char*)(s->tok + line_marker_part)) - 1;
				line_marker_part = cursor - s->tok;
				goto line_marker_str;
			}
#line 2325 "lexer.c"
yy407:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy407;
	}
	goto yy406;
}
#line 384 "../snl.re"


line_marker_str:

#line 2340 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128,   0, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128,   0, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128,   0, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
	};
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '\n') goto yy413;
	if (yych == '"') goto yy415;
	++YYCURSOR;
yy412:
#line 397 "../snl.re"
	{ goto line_marker_skip; }
#line 2385 "lexer.c"
yy413:
	++YYCURSOR;
#line 393 "../snl.re"
	{
				cursor -= 1;
				goto line_marker_skip;
			}
#line 2393 "lexer.c"
yy415:
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '\n') goto yy412;
	goto yy417;
yy416:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy417:
	if (yybm[0+yych] & 128) {
		goto yy416;
	}
	if (yych <= '\n') goto yy418;
	if (yych <= '"') goto yy419;
	goto yy421;
yy418:
	YYCURSOR = YYMARKER;
	goto yy412;
yy419:
	++YYCURSOR;
#line 389 "../snl.re"
	{
				s->file = strdupft(s->tok + line_marker_part + 1, cursor-1);
				goto line_marker_skip;
			}
#line 2419 "lexer.c"
yy421:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'b') {
		if (yych <= '7') {
			if (yych <= '&') {
				if (yych == '"') goto yy416;
				goto yy418;
			} else {
				if (yych <= '\'') goto yy416;
				if (yych <= '/') goto yy418;
				goto yy416;
			}
		} else {
			if (yych <= '[') {
				if (yych == '?') goto yy416;
				goto yy418;
			} else {
				if (yych <= '\\') goto yy416;
				if (yych <= '`') goto yy418;
				goto yy416;
			}
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'm') {
				if (yych == 'f') goto yy416;
				goto yy418;
			} else {
				if (yych <= 'n') goto yy416;
				if (yych <= 'q') goto yy418;
				goto yy416;
			}
		} else {
			if (yych <= 'u') {
				if (yych == 't') goto yy416;
				goto yy418;
			} else {
				if (yych <= 'v') goto yy416;
				if (yych != 'x') goto yy418;
			}
		}
	}
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy418;
		if (yych <= '9') goto yy416;
		goto yy418;
	} else {
		if (yych <= 'F') goto yy416;
		if (yych <= '`') goto yy418;
		if (yych <= 'f') goto yy416;
		goto yy418;
	}
}
#line 398 "../snl.re"


line_marker_skip:

#line 2483 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128,   0, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
	};
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy425;
	}
	goto yy428;
yy425:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy425;
	}
#line 402 "../snl.re"
	{ goto snl; }
#line 2535 "lexer.c"
yy428:
	++YYCURSOR;
#line 403 "../snl.re"
	{ cursor -= 1; goto snl; }
#line 2540 "lexer.c"
}
#line 404 "../snl.re"


comment:

#line 2547 "lexer.c"
{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '\n') goto yy434;
	if (yych == '*') goto yy436;
	++YYCURSOR;
yy433:
#line 409 "../snl.re"
	{ goto comment; }
#line 2558 "lexer.c"
yy434:
	++YYCURSOR;
#line 410 "../snl.re"
	{
				if (cursor == s->eof) {
					scan_report(s, "at eof: unterminated comment\n");
					DONE;
				}
				s->tok = cursor;
				s->line++;
				goto comment;
			}
#line 2571 "lexer.c"
yy436:
	yych = *++YYCURSOR;
	if (yych != '/') goto yy433;
	++YYCURSOR;
#line 408 "../snl.re"
	{ goto snl; }
#line 2578 "lexer.c"
}
#line 419 "../snl.re"


c_code:

#line 2585 "lexer.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};
	if ((YYLIMIT - YYCURSOR) < 7) YYFILL(7);
	yych = *YYCURSOR;
	if (yych <= ' ') {
		if (yych <= '\t') {
			if (yych >= '\t') goto yy443;
		} else {
			if (yych <= '\n') goto yy444;
			if (yych >= ' ') goto yy443;
		}
	} else {
		if (yych <= '#') {
			if (yych >= '#') goto yy446;
		} else {
			if (yych == '}') goto yy447;
		}
	}
	++YYCURSOR;
yy442:
#line 429 "../snl.re"
	{ goto c_code; }
#line 2643 "lexer.c"
yy443:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yybm[0+yych] & 128) {
		goto yy448;
	}
	if (yych == '#') goto yy451;
	goto yy442;
yy444:
	++YYCURSOR;
#line 434 "../snl.re"
	{
				if (cursor == s->eof) {
					scan_report(s, "at eof: unterminated literal c-code section\n");
					DONE;
				}
				s->line++;
				goto c_code;
			}
#line 2663 "lexer.c"
yy446:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x1F) {
		if (yych == '\t') goto yy452;
		goto yy442;
	} else {
		if (yych <= ' ') goto yy452;
		if (yych == 'l') goto yy455;
		goto yy442;
	}
yy447:
	yych = *++YYCURSOR;
	if (yych == '%') goto yy456;
	goto yy442;
yy448:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 6) YYFILL(6);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy448;
	}
	if (yych == '#') goto yy451;
yy450:
	YYCURSOR = YYMARKER;
	if (yyaccept == 0) {
		goto yy442;
	} else {
		goto yy454;
	}
yy451:
	yych = *++YYCURSOR;
	if (yych <= 0x1F) {
		if (yych != '\t') goto yy450;
	} else {
		if (yych <= ' ') goto yy452;
		if (yych == 'l') goto yy455;
		goto yy450;
	}
yy452:
	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	if (yych <= 0x1F) {
		if (yych == '\t') goto yy452;
	} else {
		if (yych <= ' ') goto yy452;
		if (yych == 'l') goto yy455;
	}
yy454:
#line 430 "../snl.re"
	{
				line_marker_part = cursor - s->tok;
				goto line_marker;
			}
#line 2720 "lexer.c"
yy455:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy458;
	goto yy450;
yy456:
	++YYCURSOR;
#line 423 "../snl.re"
	{
#ifdef DEBUG
				report("c_code: tok=%p", s->tok);
#endif
				LITERAL(CCODE, embedded_c_code, strdupft(s->tok, cursor - 2));
			}
#line 2734 "lexer.c"
yy458:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy450;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy450;
	yych = *++YYCURSOR;
	if (yych == '\t') goto yy461;
	if (yych != ' ') goto yy450;
yy461:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == '\t') goto yy461;
	if (yych == ' ') goto yy461;
	goto yy454;
}
#line 442 "../snl.re"


c_code_line:

#line 2756 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '\n') {
		if (yych <= 0x08) goto yy465;
		if (yych <= '\t') goto yy467;
		goto yy468;
	} else {
		if (yych == ' ') goto yy467;
	}
yy465:
	++YYCURSOR;
yy466:
#line 446 "../snl.re"
	{
				s->end = cursor;
				goto c_code_line;
			}
#line 2810 "lexer.c"
yy467:
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x08) goto yy466;
	if (yych <= '\n') goto yy471;
	if (yych == ' ') goto yy471;
	goto yy466;
yy468:
	++YYCURSOR;
#line 450 "../snl.re"
	{
				if (cursor == s->eof) {
					cursor -= 1;
				}
				s->line++;
				if (s->end > s->tok) {
					LITERAL(CCODE, embedded_c_code, strdupft(s->tok, s->end));
				}
				goto snl;
			}
#line 2830 "lexer.c"
yy470:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy471:
	if (yybm[0+yych] & 128) {
		goto yy470;
	}
	if (yych <= 0x08) goto yy472;
	if (yych <= '\n') goto yy468;
yy472:
	YYCURSOR = YYMARKER;
	goto yy466;
}
#line 460 "../snl.re"

	DONE;		/* dead code, only here to make compiler warning go away */
}

Node *parse_program(FILE *in, const char *src_file)
{
	Scanner	s;
	int	tt;		/* token type */
	Token	tv;		/* token value */
	Node	*result;	/* result of parsing */
	void	*parser;	/* the (lemon generated) parser */

	memset(&s, 0, sizeof(s));
	s.file = src_file;
	s.line = 1;
	s.in = in;

	parser = snlParserAlloc(malloc);
	do
	{
		tt = scan(&s, &tv);
                tv.symbol = tt;
#ifdef	DEBUG
		report_at(tv.file, tv.line, "%2d\t$%s$\n", tt, tv.str);
#endif
		snlParser(parser, tt, tv, &result);
	}
	while (tt);
	snlParserFree(parser, free);
	return result;
}
